function [ meas ] = sensor_modell_prob( sensor,map,mapposx,mapposy,angle,dx )
%Simple ultrasonic sensor modell
%scans a given map with the sensor and provides the measured distance.
probmax=sensor.probmax;
probrand=sensor.probrand;
sigmameas=sensor.sigmameas;
r=rand();
meas=sensor.maxdist;
%Max Measurement
if r<probmax
    return;
end
%Random Measurement
if r<probmax+probrand
    meas=sensor.maxdist*rand();
    return;
end
try
    %Normal Measurement
    minstep=1;
    % angle vectors
    vx=cos(angle);
    vy=sin(angle);
    tang2=tan(sensor.alpha/2);
    % normal vectors (ccw)
    nx=-vy;
    ny=vx;
    xang=mapposx;
    yang=mapposy;
    found=0;
    for dang=0:minstep:(sensor.maxdist/dx)
        %scan width/2
        dscan=dang*tang2;
        %start of scanline
        sx=xang-nx*dscan;
        sy=yang-ny*dscan;
        %scan
        for sc=0:minstep:dscan*2
            if sx>1 && sy>1
                if map(round(sx),round(sy))==1
                    found=1;
                    minmeas=sqrt((mapposx-sx)^2+(mapposy-sy)^2)*dx;
                    if minmeas<meas
                        meas =minmeas;
                    end
                end
            end
            sx=sx+minstep*nx;
            sy=sy+minstep*ny;
        end
        if found==1
            break;
        end
        xang=xang+vx*minstep;
        yang=yang+vy*minstep;
    end
    
    meas=min(meas+randn*sigmameas,sensor.maxdist);
catch e
    meas=sensor.maxdist;
end
end


